<template>
  <div class="card">
    <div class="card-header">
      <h1 class="card-text">Heroes y Villanos</h1>
    </div>
    <div class="card-body">
      <div class="row mb-2">
        <div class="col-12">
          <div class="float-right">
            <router-link class="btn btn-primary" :to="{name: 'Heroes.crear'}"><i class="fas fa-plus-circle"></i> Crear</router-link>
          </div>
        </div>
      </div>
      <div class="table-responsive">
        <table class="table table-hover table-striped">
          <thead class="thead-dark">
            <tr>
              <th scope="col">Nombre</th>
              <th scope="col">Alias</th>
              <th scope="col">Especialidad</th>
              <th scope="col">Ocupacion</th>
              <th scope="col">Genero</th>
              <th scope="col">Opciones</th>
            </tr>
          </thead>
          <tbody>
            <tr v-for="(heroe, index) in heroes" :key="index">
              <td>{{heroe.nombre | capitalize}}</td>
              <td>{{heroe.alias | capitalize}}</td>
              <td>{{heroe.especialidad | capitalize}}</td>
              <td>{{heroe.ocupacion | capitalize}}</td>
              <td>{{heroe.genero | capitalize}}</td>
              <td>
                <div class="btn-group" role="group" aria-label="Basic example">
                  <router-link
                    class="btn btn-info"
                    :to="{name: 'Heroes.detalle', params: {codigo: heroe.codigo}}"
                  >
                    <i class="fas fa-eye"></i>
                  </router-link>
                  <router-link
                    class="btn btn-secondary"
                    :to="{name: 'Heroes.editar', params: {codigo: heroe.codigo}}"
                  >
                    <i class="fas fa-edit"></i>
                  </router-link>
                  <button
                    type="button"
                    class="btn btn-danger"
                    :disabled="eliminando"
                    @click="eliminar(heroe.codigo, heroe.nombre)"
                  >
                    <i class="fas fa-trash-alt"></i>
                  </button>
                </div>
              </td>
            </tr>
            <tr v-if="heroes.length === 0">
              <td colspan="6" class="text-center">Sin registros a mostrar</td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </div>
</template>

<script>
import { mapActions, mapState } from 'vuex'

export default {
  created() {
    this.getHeroes()
  },
  data() {
    return {
      eliminando: false
    }
  },
  methods: {
    ...mapActions('heroes', ['setHeroes']),
    getHeroes () {
      let config = {
        headers: {
          'Accept': 'application/json',
          'Authorization': `Bearer ${this.token.token}`,
          'apikey': this.usuario.apikey
        }
      }
      this.axios.get('/v1/heroes', config)
        .then((res) => {
          Toast.fire({
            icon: 'success',
            title: res.data.message
          })
          this.setHeroes(res.data.body.heroes)
        })
        .catch(e => {
          Toast.fire({
            icon: 'error',
            title: e.response.data.message
          })
        })
    },
    eliminar(codigo, nombre) {
      this.eliminando = true
      let config = {
        headers: {
          'Accept': 'application/json',
          'Authorization': `Bearer ${this.token.token}`,
          'apikey': this.usuario.apikey
        }
      }
      Swal.fire({
        title: `Quieres eliminar a ${nombre}?`,
        text: 'Esto no podra ser revertido.',
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Si, eliminar',
        allowOutsideClick: false,
        allowEscapeKey: false,
        allowEnterKey: false
      })
      .then(result => {
        if (result.isConfirmed) {
          this.axios.delete(`/v1/heroes/${codigo}`, config)
            .then(res => {
              this.eliminando = false
              Toast.fire({
                icon: 'success',
                title: res.data.message
              })
              this.getHeroes()
            })
            .catch(e => {
              this.eliminando = false
              Toast.fire({
                icon: 'error',
                title: e.response.data.message
              })
            })
        }
        else {
          this.eliminando = false
        }
      })
    }
  },
  computed: {
    ...mapState('heroes', ['heroes']),
    ...mapState('usuario', ['usuario', 'token'])
  }
}
</script>
